addHook("AbilitySpecial", function(player)
	player.sonic_usedmultispin = $ or false
	if player.mo and player.mo.skin == "sonic" and player.sonic_usedmultispin == false
		player.pflags = $1 & ~PF_SPINNING
		player.pflags = $1|PF_THOKKED
		player.mo.state = S_PLAY_SPINDASH
		S_StartSound(player.mo, sfx_spndsh)
		for i = 0, 8
		end
	end
end)

addHook("PlayerThink", function(player)
	player.sonic_multispin = $ or false; player.sonic_multispinpower = $ or 0; player.sonic_usedmultispin = $ or false
	if player.mo.eflags & MFE_JUSTHITFLOOR or P_IsObjectOnGround(player.mo)
		player.sonic_usedmultispin = false; player.sonic_multispinpower = 10
	end
	if player.mo and player.mo.skin == "sonic" and player.pflags & PF_THOKKED and player.sonic_usedmultispin == false
		if player.pflags & PF_JUMPDOWN
			player.jumpdown = true
			player.sonic_multispin = true
			if player.speed >= 30*FRACUNIT
				player.mo.momz = $*9/10
			else
				player.mo.momz = $*10/11
			end
		else
			player.jumpdown = false
		end
		if player.sonic_multispin == true
			if leveltime % 15 == 0
				player.sonic_multispinpower = $ + 5
			end
		end
		if player.sonic_multispinpower == 30
			player.sonic_multispin = false; player.sonic_usedmultispin = true
			player.mo.state = S_PLAY_ROLL; player.pflags = $ & ~PF_JUMPED; S_StartSound(player.mo, sfx_s3k51)
			player.sonic_multispinpower = 10
		end
		if player.sonic_multispinpower <= 30
			if leveltime % 15 == 0
				S_StartSound(player.mo, sfx_spndsh)
			end
		end
		if player.sonic_multispin == true and player.pflags & PF_JUMPDOWN == 0
			S_StartSound(player.mo, sfx_thok)
			 local thdust = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_THOK)
			 if not (player.mo.eflags & MFE_UNDERWATER)
				P_SetObjectMomZ(player.mo, 8*FRACUNIT, false)
				P_InstaThrust(player.mo, player.mo.angle, 40*FRACUNIT+player.sonic_multispinpower)
			else
				P_SetObjectMomZ(player.mo, 8*FRACUNIT/2, false)
				P_InstaThrust(player.mo, player.mo.angle, 20*FRACUNIT+player.sonic_multispinpower)
			end
			player.mo.state = S_PLAY_ROLL; player.sonic_multispin = false; player.sonic_usedmultispin = true
			player.sonic_multispinpower = 10
		end
		if player.sonic_multispin == true and player.mo.eflags & MFE_TOUCHWATER and player.speed >= 24*FRACUNIT
			P_SetObjectMomZ(player.mo, 7*FRACUNIT, false)
			S_StartSound(player.mo, sfx_splish)
			P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPLISH)
			player.sonic_multispinpower = 10
		end
	end
end)
//Spin when you hit the floor when "Multi spinning"
addHook("PlayerThink", function(player)
		if player.mo.skin == "sonic"
		and player.speed < 45*FRACUNIT
		and player.sonic_multispin == true
		and not player.powers[pw_super]
		and (P_IsObjectOnGround(player.mo) == true) then
				S_StartSound(player.mo, sfx_zoom)
				player.mo.state = S_PLAY_ROLL
				player.sonic_multispin  = false
				player.pflags = $|PF_SPINNING
				P_Thrust(player.mo, player.mo.angle, 20*FRACUNIT)
		end
		if player.mo.skin == "sonic"
		and player.sonic_multispin  == true
		and player.powers[pw_super]
		and player.speed < 60*FRACUNIT
		and (P_IsObjectOnGround(player.mo) == true) then
				S_StartSound(player.mo, sfx_zoom)
				player.mo.state = S_PLAY_ROLL
				player.sonic_multispin  = false
				player.pflags = $|PF_SPINNING
				P_Thrust(player.mo, player.mo.angle, 50*FRACUNIT)
				P_NukeEnemies(player.mo, player.mo, 1)
				P_StartQuake(20*FRACUNIT, 4)
		end
    end)
	
	
//Wall Spin i'm so sorry kirb but I don't like wall checks
addHook("MobjMoveBlocked", function(mo)
    local player = mo.player
    if player.sonic_multispin == true
	and not player.powers[pw_super]
	P_SetObjectMomZ(player.mo, 10*FRACUNIT + player.speed/4)
	player.sonic_multispin = false
	S_StartSound(player.mo, sfx_zoom)
	player.mo.state = S_PLAY_SPINDASH
	player.pflags = $|PF_SPINNING
	end
end, MT_PLAYER)


addHook("MobjMoveBlocked", function(mo)
    local player = mo.player
    if player.sonic_multispin == true
	and player.powers[pw_super]
	P_SetObjectMomZ(player.mo, 15*FRACUNIT + player.speed/4)
	player.sonic_multispin = false
	P_StartQuake(20*FRACUNIT, 4)
	P_NukeEnemies(player.mo, player.mo, 1)
	S_StartSound(player.mo, sfx_zoom)
	player.mo.state = S_PLAY_SPINDASH
	player.pflags = $|PF_SPINNING
	end
end, MT_PLAYER)